<?php 
class franchise{
	private $domain;
	function __construct($url){
		$this->domain=$url;
	}
	private function readsetting(){
		   $path=self::geturl();
			if(!file_exists($path)){
		    $final['sts']=0;
			$final['msg']="Domain not found.";			
			echo json_encode($final);
			die;
			}
         return parse_ini_file($path,true);		
    }
	private function geturl(){	
		$httphost=$this->domain;		
        $httphost=str_replace("www.","",$httphost);
		$httphost=str_replace("http://","",$httphost);			
		return dirname(__FILE__)."/../../configration/".$httphost."/data.ini";			
	}
    private function db_connect() {
        static $connection;
        if(!isset($connection)) {
			$config=self::readsetting();	
            if (function_exists('mysqli_connect')){
			$connection = mysqli_connect($config['database']['host'],$config['database']['username'],$config['database']['password'],$config['database']['database']);                 
			}else{	
            $connection = new PDO("mysql:host=".$config['database']['host'].";dbname=".$config['database']['database'], $config['database']['username'],$config['database']['password']);			
		}
        }
        if($connection === false) {
            $final['sts']=0;
			$final['msg']="Database Connection Failed.";
			echo json_encode($final);
			die;
        }
        return $connection;
    }
    private function execute($query,$id=false) {
        $connection = self::db_connect();
		if (function_exists('mysqli_connect')){
        $result=mysqli_query($connection,$query);  
		if(!$connection->errno){
        if($id){
			$result=mysqli_insert_id($connection);
		}
		}
		else{
			$final['sts']=0;
			$final['msg']=$connection->error;
			echo json_encode($final);
			die;				
		}
	}else{
	    $result =  $connection->query($query);
        if($result){
		if($id)	{
       $result=$connection->lastInsertId();
	   }
		}
        else 
		{			
			$final['sts']=0;
			$final['msg']=$connection->errorInfo();
			echo json_encode($final);
			die;
		}
	}
		return $result;
	}
	private function query($query,$fetch=1) {
        $connection = self::db_connect();
		if (function_exists('mysqli_connect')){
		$result=mysqli_query($connection,$query); 	
		if(!$connection->errno){	
		$results=mysqli_fetch_array($result,$fetch);
		}
		else{
			$final['sts']=0;
			$final['msg']=$connection ->error;
			echo json_encode($final);
			die;
		}
		}else{
		$result=$connection->prepare($query);
        $result->execute();
		if($fetch==2)
			$results= $result->fetch();	
		if($fetch==1)
        $results= $result->fetch(PDO::FETCH_ASSOC);	
		}
		return $results;
    }
	private function queryall($query,$fetch=1) {
       $connection = self::db_connect();
	   if (function_exists('mysqli_connect')){
		$result=mysqli_query($connection,$query); 	
		if(!$connection->errno){	
		$results=mysqli_fetch_all($result,$fetch);
		}
		else{
			$final['sts']=0;
			$final['msg']=$connection ->error;
			echo json_encode($final);
			die;
		}
	   }else{
		$result=$connection->prepare($query);
        $result->execute();
		if($fetch==2)
			$results= $result->fetch();
		if($fetch==1)
        $results= $result->fetchAll(PDO::FETCH_ASSOC);  
	   }
		return $results;
    }
	function clientdetails(){
	return $this->query("select name as takeaway_name,address1 as no,address2 as street,city,state,pincode as postcode,country,mobile,phone,phone2,phone3 from tbl_contact");	
	}
	function ordermode(){
	return $this->query("select mode from tbl_mode");	
	}
	function openingtime(){
	return $this->query("select monday_ct1 as monday, 	tuesday_ct2 as tuesday,wednesday_ct3 as wednesday,thursday_ct4 as thursday,friday_ct5 as friday,saturday_ct6 as saturday,sunday_ct7 as sunday,dtime as check_header from tbl_contacttime");	
	}
	private function getorderconfig(){
	return $this->query("select * from tbl_config_order");
	}
	private function searchpostcode($postcode){
	$code=str_replace(" ","",$postcode);
	$result=array();
	while(strlen($code)>2){
	if($rs=$this->checkcode($code))
	{
	return $rs;
	}
	$code=substr($code,0,strlen($code)-1);		
	}
	return $result;
	}
	private function checkcode($code){
	$result=array();
	$sql="select * from tbl_postcodelist where REPLACE(postcode, ' ', '') =  '$code' and status='1'";
	if($row=$this->query($sql))
	{
	$result=$row;
	}
	return $result;	
	}
	private function getradius(){
	return $this->queryall("select * from tbl_radius");
	}
	private function getdistance($postcode1,$postcode2){
	$postcode1=str_replace(" ","",$postcode1);
	$postcode2=str_replace(" ","",$postcode2);
	$url ="https://maps.googleapis.com/maps/api/distancematrix/json?origins=$postcode2&destinations=$postcode1&mode=driving&language=en-EN&sensor=false&key=AIzaSyDMeETPBVNDipWi5uFeeF9NijSXEowgtnw";
	$data = @file_get_contents($url);
	$result = json_decode($data, true);
	$distance = array( // converts the units
    "meters" => $result["rows"][0]["elements"][0]["distance"]["value"],
    "kilometers" => $result["rows"][0]["elements"][0]["distance"]["value"] / 1000,
    "yards" => $result["rows"][0]["elements"][0]["distance"]["value"] * 1.0936133,
    "miles" => $result["rows"][0]["elements"][0]["distance"]["value"] * 0.000621371
	);
	$val=$this->getorderconfig();
	$val1=$this->getradius();
	$dis;
	if($val['discalc']=='1')
	$dis=$distance['kilometers'];
	else
	$dis=$distance['miles'];
	$amt=0;	
	if($val['maxradius']<$dis)
	$result['status']="";
	else{
	$amt=$val1[$dis]['charge'];	
	$round=$val1[$dis]['round'];	
	}
	$result['dist']=$dis;
	$result['round']=$round;
	$result['amt']=$amt;
	return $result;
	}
	function deliverystatus($postcode){
	$oconfig=$this->getorderconfig();
	if($oconfig['dtype']==0){
	$codeinfo=$this->searchpostcode(str_replace(" ","",$postcode));
	if(count($codeinfo)){
	unset($codeinfo['status']);
	unset($codeinfo['id']);
	$codeinfo['status']=true;
	}	
	else
	$codeinfo['status']=false;
	}
	else{
	$d=$this->clientdetails();
	$pincode=$d['postcode'];
	$postcode1=str_replace(" ","",$postcode);
	$postcode2=$pincode;
	$codeinfo=$this->getdistance($postcode1,$postcode2);
	if($codeinfo['rows'][0]['elements'][0]['status']=="OK" && $codeinfo['status'])
	{
	$codeinfo['status']=true;	
	}else{
	$codeinfo=array();	
	$codeinfo['status']=false;
	}
	}
	return $codeinfo;
	}	
}
	?>