<?php 
class account{
	private $domain;
	private $secure_key;
	private $url_key;
	function __construct($url){
		$this->domain=$url;
		$checktable = $this->query("SHOW TABLES LIKE 'tbl_user_login'");
		$table_exists =$checktable;
		if(!$table_exists){
		$sql="CREATE TABLE tbl_user_login (
		id INT(11) UNSIGNED AUTO_INCREMENT PRIMARY KEY,
		`username` varchar(255) NOT NULL,
		`password` varchar(255) NOT NULL,
		status int(10) NOT NULL
		)";
		$this->execute($sql);	
		}
		$checktable = $this->query("SHOW TABLES LIKE 'tbl_user_profile'");
		$table_exists = $checktable;
		if(!$table_exists){
		$sql="CREATE TABLE tbl_user_profile (
		id INT(11) UNSIGNED AUTO_INCREMENT PRIMARY KEY,
		uid int(10) NOT NULL,
		`fname` varchar(255) NOT NULL,
		`lname` varchar(255) NOT NULL,
		`email` varchar(255) NOT NULL,
		`contactno` varchar(255) NOT NULL,
		smsdnd int(10) NOT NULL,
		emaildnd int(10) NOT NULL
		)";
		$this->execute($sql);	
		}
		$checktable = $this->query("SHOW TABLES LIKE 'tbl_user_address'");
		
		$table_exists = $checktable;
		if(!$table_exists){
		$sql="CREATE TABLE tbl_user_address (
		id INT(11) UNSIGNED AUTO_INCREMENT PRIMARY KEY,
		 uid int(10) NOT NULL,
		`dno` varchar(255) NOT NULL,
		`add1` varchar(255) NOT NULL,
		`add2` varchar(255) NOT NULL,
		`postcode` varchar(25) NOT NULL,
		status int(10) NOT NULL
		)";
		$this->execute($sql);	
		}
		$checktable = $this->query("SHOW TABLES LIKE 'tbl_email_block'");
		
		$table_exists = $checktable;
		if(!$table_exists){
		$sql="CREATE TABLE tbl_email_block (
		id INT(11) UNSIGNED AUTO_INCREMENT PRIMARY KEY,
		`email` varchar(255) NOT NULL unique,
		status int(10) NOT NULL
		)";
		$this->execute($sql);	
		}
		$checktable = $this->query("SHOW TABLES LIKE 'tbl_sms_block'");
		
		$table_exists = $checktable;
		if(!$table_exists){
		$sql="CREATE TABLE tbl_sms_block (
		id INT(11) UNSIGNED AUTO_INCREMENT PRIMARY KEY,
		`phone` varchar(25) NOT NULL unique,		
		status int(10) NOT NULL
		)";
		$this->execute($sql);	
		}
		$this->url_key="!^%!$!@&";
	}
	private function readsetting(){
		   $path=self::geturl();
			if(!file_exists($path)){
		    $final['sts']=0;
			$final['msg']="Domain not found.";			
			echo json_encode($final);
			die;
			}
         return parse_ini_file($path,true);		
    }
	private function geturl(){	
		$httphost=$this->domain;
        $httphost=str_replace("www.","",$httphost);
		$httphost=str_replace("http://","",$httphost);	
		if($_SERVER['HTTP_HOST']=="localhost" || strpos($_SERVER['HTTP_HOST'],"192.168")!==false)
		return dirname(__FILE__)."/../../dbs/".$httphost."/data.ini";	
		else
			return dirname(__FILE__)."/../../configration/".$httphost."/data.ini";		
	}
    private function db_connect() {
        static $connection;
        if(!isset($connection)) {
			$config=self::readsetting();	
            if (function_exists('mysqli_connect')){
			$connection = mysqli_connect($config['database']['host'],$config['database']['username'],$config['database']['password'],$config['database']['database']);                 
			}else{	
            $connection = new PDO("mysql:host=".$config['database']['host'].";dbname=".$config['database']['database'], $config['database']['username'],$config['database']['password']);			
		}
        }
        if($connection === false) {
            $final['sts']=0;
			$final['msg']="Database Connection Failed.";
			echo json_encode($final);
			die;
        }
        return $connection;
    }
    private function execute($query,$id=false) {
        $connection = self::db_connect();
		if (function_exists('mysqli_connect')){
        $result=mysqli_query($connection,$query);  
		if(!$connection->errno){
        if($id){
			$result=mysqli_insert_id($connection);
		}
		}
		else{
			$final['sts']=0;
			$final['msg']=$connection->error;
			echo json_encode($final);
			die;				
		}
	}else{
	    $result =  $connection->query($query);
        if($result){
		if($id)	{
       $result=$connection->lastInsertId();
	   }
		}
        else 
		{			
			$final['sts']=0;
			$final['msg']=$connection->errorInfo();
			echo json_encode($final);
			die;
		}
	}
		return $result;
	}
	private function executesecure($query,$values=array(),$id=false) {
        $connection = self::db_connect();
		if (function_exists('mysqli_connect')){
			$pre="";
			foreach($values as $val){
				$pre.="s";
			}
        if($result=$this->mysqli_prepared_query($connection,$query,$pre,$values)){
		if(!$connection->errno){
        if($id){
			$result=mysqli_insert_id($connection);
		}
		}
		else{
			$final['sts']=0;
			$final['msg']=$connection->error;
			echo json_encode($final);
			die;				
		}
		}
	}else{		
	    $result = $connection->prepare($query);
		for($i=0;$i<count($values);$i++){
		$result->bindParam(($i+1),$values[$i]);	
		}
		$result->execute();
        if($result){
		if($id)	{
       $result=$connection->lastInsertId();
	   }
		}
        else 
		{			
			$final['sts']=0;
			$final['msg']=$connection->errorInfo();
			echo json_encode($final);
			die;
		}
	}
		return $result;
	}
	private function query($query,$fetch=1) { 
        $connection = self::db_connect();
		if (function_exists('mysqli_connect')){
		$result=mysqli_query($connection,$query); 	
		if(!$connection->errno){	
		$results=mysqli_fetch_array($result,$fetch);
		}
		else{
			$final['sts']=0;
			$final['msg']=$connection ->error;
			echo json_encode($final);
			die;
		}
		}else{
		$result=$connection->prepare($query);	
        $result->execute();
		if($fetch==2)
			$results= $result->fetch();	
		if($fetch==1)
        $results= $result->fetch(PDO::FETCH_ASSOC);	
		}
		return $results;
    }
	private function querysecure($query,$values,$fetch=1) {
        $connection = self::db_connect();
		if (function_exists('mysqli_connect')){
		$result=mysqli_query($connection,$query); 
        $pre="";
			foreach($values as $val){
				$pre.="s";
			}
        if($result=$this->mysqli_prepared_query($connection,$query,$pre,$values)){		
		if(!$connection->errno){	
		$results=$result[0];
		}
		else{
			$final['sts']=0;
			$final['msg']=$connection ->error;
			echo json_encode($final);
			die;
		}
		}
		}else{
		$result=$connection->prepare($query);
		for($i=0;$i<count($values);$i++){
		$result->bindParam(($i+1),$values[$i]);	
		}
        $result->execute();
		if($fetch==2)
			$results= $result->fetch();	
		if($fetch==1)
        $results= $result->fetch(PDO::FETCH_ASSOC);	
		}
		return $results;
    }
	private function queryallsecure($query,$values,$fetch=1) {
        $connection = self::db_connect();
		if (function_exists('mysqli_connect')){
		$result=mysqli_query($connection,$query); 
        $pre="";
			foreach($values as $val){
				$pre.="s";
			}
        if($result=$this->mysqli_prepared_query($connection,$query,$pre,$values)){		
		if(!$connection->errno){	
		$results=$result;
		}
		else{
			$final['sts']=0;
			$final['msg']=$connection ->error;
			echo json_encode($final);
			die;
		}
		}
		}else{
		$result=$connection->prepare($query);
		for($i=0;$i<count($values);$i++){
		$result->bindParam(($i+1),$values[$i]);	
		}
        $result->execute();
		if($fetch==2)
			$results= $result->fetchAll();	
		if($fetch==1)
        $results= $result->fetchAll(PDO::FETCH_ASSOC);	
		}
		return $results;
    }
	private function queryall($query,$fetch=1) {
       $connection = self::db_connect();
	   if (function_exists('mysqli_connect')){
		$result=mysqli_query($connection,$query); 	
		if(!$connection->errno){	
		$results=mysqli_fetch_all($result,$fetch);
		}
		else{
			$final['sts']=0;
			$final['msg']=$connection ->error;
			echo json_encode($final);
			die;
		}
	   }else{
		$result=$connection->prepare($query);
        $result->execute();
		if($fetch==2)
			$results= $result->fetch();
		if($fetch==1)
        $results= $result->fetchAll(PDO::FETCH_ASSOC);  
	   }
		return $results;
    }   
	private function mysqli_prepared_query($link,$sql,$typeDef = FALSE,$params = FALSE){
  if($stmt = mysqli_prepare($link,$sql)){
    if(count($params) == count($params,1)){
      $params = array($params);
      $multiQuery = FALSE;
    } else {
      $multiQuery = TRUE;
    } 
   
    if($typeDef){
      $bindParams = array();   
      $bindParamsReferences = array();
      $bindParams = array_pad($bindParams,(count($params,1)-count($params))/count($params),"");        
      foreach($bindParams as $key => $value){
        $bindParamsReferences[$key] = &$bindParams[$key]; 
      }
      array_unshift($bindParamsReferences,$typeDef);
      $bindParamsMethod = new ReflectionMethod('mysqli_stmt', 'bind_param');
      $bindParamsMethod->invokeArgs($stmt,$bindParamsReferences);
    }
   
    $result = array();
    foreach($params as $queryKey => $query){
      foreach($bindParams as $paramKey => $value){
        $bindParams[$paramKey] = $query[$paramKey];
      }
      $queryResult = array();
      if(mysqli_stmt_execute($stmt)){
        $resultMetaData = mysqli_stmt_result_metadata($stmt);
        if($resultMetaData){                                                                              
          $stmtRow = array();  
          $rowReferences = array();
          while ($field = mysqli_fetch_field($resultMetaData)) {
            $rowReferences[] = &$stmtRow[$field->name];
          }                               
          mysqli_free_result($resultMetaData);
          $bindResultMethod = new ReflectionMethod('mysqli_stmt', 'bind_result');
          $bindResultMethod->invokeArgs($stmt, $rowReferences);
          while(mysqli_stmt_fetch($stmt)){
            $row = array();
            foreach($stmtRow as $key => $value){
              $row[$key] = $value;          
            }
            $queryResult[] = $row;
          }
          mysqli_stmt_free_result($stmt);
        } else {
          $queryResult[] = mysqli_stmt_affected_rows($stmt);
        }
      } else {
        $queryResult[] = FALSE;
      }
      $result[$queryKey] = $queryResult;
    }
    mysqli_stmt_close($stmt);  
  } else {
    $result = FALSE;
  }
 
  if($multiQuery){
    return $result;
  } else {
    return $result[0];
  }
} 
function checkemail($email){
return $this->querysecure("select * from tbl_user_login where username=?",array($email));	
}
private function getuserbytoken($token){
	$this->secure_key=$this->url_key;
	$id=$this->decodeuser($token);
	return 	$this->checkeid($id);
}
function getloginuser($token){
	$this->secure_key=$this->url_key;
	$id=$this->decodeuser($token);
	return 	$this->checkeid($id);
}
private function checkeid($id){
return $this->querysecure("select * from tbl_user_login where id=?",array($id));	
}
private function gethashing($password){
	$options = [
    'cost' => 11,
    'salt' => mcrypt_create_iv(22, MCRYPT_DEV_URANDOM),
];
return password_hash($password, PASSWORD_BCRYPT, $options);
}
function encodeemail($password){
	$options = [
    'cost' => 8,
    'salt' => mcrypt_create_iv(22, MCRYPT_DEV_URANDOM),
];
return password_hash($password, PASSWORD_BCRYPT, $options);
}
private function verifyhashing($password,$hash){ 
if(password_verify($password, $hash)){
   return true;
}else{
   return false;
}
}
function verifyresethashing($val){ 
$user=$this->checkemail($val['email']);
if($user){
if(password_verify($user['id'], $val['token'])){
   return true;
}else{
   return false;
}
}
return false;	
}
function updatepassword($val){
	if($this->verifyresethashing($val)){
	$this->executesecure("update `tbl_user_login` set password=? where username=?",array($this->gethashing($val['password']),addslashes($val['email'])));
	return true;
	}
	return false;
}
function verifyunsubhashing($val){ 
if($this->verifyhashing($val['email'],$val['token'])){
   return true;
}else{
   return false;
}
}
function updateunsubemail($val){
	if($this->verifyunsubhashing($val)){	
	$this->addemailblocklist($val['email']);
	return true;
	}
	return false;
}
function login($val){
	$user=$this->checkemail($val['email']);
	if($user){
	if($this->verifyhashing($val['password'],$user['password'])){
		$this->secure_key=$val['password'];
		return $this->createsession($user['id'],$val['password']);
	}
	return false;
	}
	return false;
}
function forgot($val){
	$user=$this->checkemail($val['email']);
	if($user){
	$val=$this->getprofile($user['id']);
	$param="token=".urlencode($this->gethashing($val['uid']))."&email=".urlencode($val['email']);
	return email::forgot($val,$param);
	}
	return false;
}
private function createsession($id,$pass){ 
	$token=$this->encodeuser($id); 
	$this->secure_key=$this->url_key;
	$key=$this->encodeuser($pass);
	return file_get_contents("http://www.myaccount.slicepizza.uk/include.php?settoken=".urlencode($token)."&key=".urlencode($key));
}
function setuser($token,$key){ 
$this->secure_key=$this->url_key;
$key=$this->decodeuser($key);
$this->secure_key=$key;
$id=$this->decodeuser($token);
$user=$this->checkeid($id);
if($this->verifyhashing($key,$user['password'])){
$this->secure_key=$this->url_key;
return $this->encodeuser($id); 
}
return false;
}
private function encodeuser($id){ error_reporting(E_ALL);
    $key=$this->secure_key;
	return base64_encode(mcrypt_encrypt(MCRYPT_RIJNDAEL_256, md5($key), $id, MCRYPT_MODE_CBC, md5(md5($key))));
}
private function decodeuser($token){
	$key=$this->secure_key;
	return rtrim(mcrypt_decrypt(MCRYPT_RIJNDAEL_256, md5($key), base64_decode($token), MCRYPT_MODE_CBC, md5(md5($key))), "\0");
}
private function gettoken($id){
return $this->querysecure("select token from `tbl_user_active` where id=?",array($id));	
}
private function deletetoken($id){
return $this->querysecure("delete from `tbl_user_active` where uid=?",array($id));	
}
 function createaccount($val){
	 if($this->checkemail($val['email']))
	 {
		 return false;
	 }
	$id=$this->executesecure("INSERT INTO `tbl_user_login`(`username`, `password`, `status`) VALUES (?,?,?)",array(addslashes($val['email']),
	$this->gethashing($val['password']),0),true);	
	if($id){
		$val['uid']=$id;
		$this->addprofile($val);
		$this->addaddress($val);
		return $id;
	}
	}	
	private function addaddress($val){
		$this->executesecure("INSERT INTO `tbl_user_address`(`uid`, `dno`, `add1`, `add2`, `postcode`, `status`)VALUES(?,?,?,?,?,?)",array(addslashes($val['uid']),addslashes($val['dno']),addslashes($val['street']),addslashes($val['town']),addslashes($val['postalcode']),1));		
	}
	function getdefaultaddress($uid){
		return $this->querysecure("select * from `tbl_user_address` where `status`=? and uid=?",array(1,$uid));
	}
	private function addprofile($val){
		$this->executesecure("INSERT INTO `tbl_user_profile`(`uid`, `fname`, `lname`, `email`, `contactno`, `smsdnd`, `emaildnd`)VALUES (?,?,?,?,?,?,?)",array(addslashes($val['uid']),addslashes($val['firstname']),addslashes($val['lastname']),addslashes($val['email']),addslashes($val['phone']),addslashes($val['smscheck']),addslashes($val['emailcheck'])));
		if(!$val['emailcheck'])
			$this->addemailblocklist($val['email']);
		if(!$val['smscheck'])
			$this->addsmsblocklist($val['phone']);
			
	}
	private function getprofile($uid){
		return $this->querysecure("select * from `tbl_user_profile` where uid=?",array($uid));
	}
	function addemailblocklist($email){
		return $this->executesecure("INSERT INTO `tbl_email_block`(`email`,`status`)VALUES(?,?)",array(addslashes($email),1));
	}
	function addsmsblocklist($phone){
		return $this->executesecure("INSERT INTO `tbl_sms_block`(`phone`,`status`)VALUES(?,?)",array(addslashes($phone),1));
	}
	function checkemailblocklist($email){
		return $this->querysecure("select * from `tbl_email_block` where email=?",array($email));
	}
}
	?>